# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
image: lorisleiva/laravel-docker:latest

stages:
  - build
  - test
# The job's name.
composer:

  # The job's stage (build, test or deploy).
  stage: build

  # What to run on the job.
  script:
    - composer install
    - cp .env.example .env
    - composer dump-autoload
    - php artisan key:generate
    - php artisan migrate
    - php artisan db:seed
    - composer require pestphp/pest --dev --with-all-dependencies
    - php artisan vendor:publish --provider="Pest\PestServiceProvider"
  artifacts:
    # (Optional) Give it an expiration date,
    # after that period you won't be able to
    # download them via the UI anymore.
    expire_in: 1 month

    # Define what to output from the job.
    paths:
      - vendor
      - .env
  cache:

    # The variable CI_COMMIT_REF_SLUG
    # refers to the slug of the branch.
    # For example: `master` for the master branch.
    # We use the `composer` suffix to avoid conflicts with
    # the `npm` cache that we'll define next.
    key: ${CI_COMMIT_REF_SLUG}-composer

    # Define what to cache.
    paths:
      - vendor
      - .env
pesttest:
  stage: test
  dependencies:
    - composer
  script:
    - php vendor/bin/pest
sast:
  stage: test
include:
- template: Security/SAST.gitlab-ci.yml
